Team13-SocialMedia/SocialMedia.Web/Controllers/SettingsController.cs
using Microsoft.AspNetCore.Authorization;
using Microsoft.AspNetCore.Http;
using Microsoft.AspNetCore.Mvc;
using Microsoft.AspNetCore.Mvc.Rendering;
using SocialMedia.Services.Contracts;
using SocialMedia.Services.DTOs;
using System;
using System.IO;
using System.Security.Claims;
using System.Threading.Tasks;

namespace SocialMedia.Web.Controllers
{
    [Authorize]
    public class SettingsController : Controller
    {
        private readonly IUserService _userService;
        private readonly ICountryService _countryService;
        private readonly IPictureService _pictureService;

        public SettingsController(IUserService userService, ICountryService countryService, IPictureService pictureService)
        {
            _userService = userService;
            _countryService = countryService;
            _pictureService = pictureService;
        }

        private int UserId
        {
            get
            {
                return int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));
            }
        }

        private async Task<ViewResult> GetView()
        {
            return View(await _userService.Get(this.UserId));
        }

        public async Task<IActionResult> Index()
        {
            ViewData["CountryList"] = new SelectList(await _countryService.GetMany(), "Id", "Name");

            return await GetView();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Index(UserDTO model)
        {
            bool result = true;

            result &= int.TryParse(Request.Form["birthDay"], out int day);
            string month = Request.Form["birthMonth"];
            result &= int.TryParse(Request.Form["birthYear"], out int year);
            result &= DateTime.TryParse($"{year}/{month}/{day}", out DateTime dateOfBirth);

            if (result)
            {
                int userId = int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));

                model.DateOfBirth = dateOfBirth;
                model.About = Request.Form["aboutSection"].ToString();
                model.Age = (DateTime.Now - dateOfBirth).Days / 365;

                await _userService.Update(userId, model);
            }

            return RedirectToAction(nameof(Index));
        }

        public async Task<IActionResult> Password()
        {
            return await GetView();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Password(int id)
        {
            string oldPassword = Request.Form["oldPassword"].ToString();
            string newPassword = Request.Form["newPassword"].ToString();

            int userId = int.Parse(User.FindFirstValue(ClaimTypes.NameIdentifier));

            await _userService.ChangePassword(userId, oldPassword, newPassword);

            return RedirectToAction(nameof(Index));
        }

        public async Task<IActionResult> Account()
        {
            ViewData["PrivacyOptions"] = new (string Name, int Value)[]
            {
                ("Private", 0),
                ("Friends Only", 1),
                ("Public", 2)
            };

            return await GetView();
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> Account(int id)
        {
            if (byte.TryParse(Request.Form["PrivacySetting"], out byte setting))
            {
                await _userService.UpdatePrivacy(this.UserId, setting);
            }

            return RedirectToAction(nameof(Index));
        }

        [HttpPost]
        [ValidateAntiForgeryToken]
        public async Task<IActionResult> UploadPfp(IFormFile file)
        {
            await _pictureService.EditProfilePicture(UserId, file);

            return RedirectToAction(nameof(Index));
        }
    }
}

Team13-SocialMedia/SocialMedia.Web/Views/Shared/_Layout.cshtml
<!DOCTYPE html>
<html lang="en">
<head>
    <meta http-equiv="Content-Type" content="text/html; charset=utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0">
    <meta name="description" content="" />
    <meta name="keywords" content="" />
    <title>@ViewData["Title"] - Dolphin+</title>
    <link rel="icon" href="~/images/fav.png" type="image/png" sizes="16x16">

    <link rel="stylesheet" href="~/css/main.min.css">
    <link rel="stylesheet" href="~/css/strip.css">
    <link rel="stylesheet" href="~/css/style.css">
    <link rel="stylesheet" href="~/css/color.css">
    <link rel="stylesheet" href="~/css/responsive.css">
</head>

<body>
    <div class="theme-layout">


        <div class="topbar stick">
            <div class="logo">
                <a asp-controller="Home" asp-action="Index"><img src="~/images/textlogo.png" width="130" height="40" alt=""></a>
            </div>

            <div class="top-area">

                <div class="top-search">
                    <form>
                        <input type="text" placeholder="Find Post" onkeypress='handle(event, "/Post?searchQuery=" + this.value)'>
                    </form>
                </div>

                <partial name="_LoginPartial.cshtml" />
            </div>
        </div>

        @RenderBody()

        <div class="bottombar">
            <div class="container">
                <div class="row">
                    <div class="col-md-12">
                        <span class="copyright"><a href="">Dolphin+ - ©2020</a></span>
                        <i><img src="~/images/credit-cards.png" alt=""></i>
                    </div>
                </div>
            </div>
        </div>

    </div>

    <script src="~/js/main.min.js"></script>
    <script src="~/js/script.js"></script>
    <script src="~/js/site.js"></script>

</body>
</html>

Team13-SocialMedia/SocialMedia.Web/Views/Shared/_ProfilePartial.cshtml
@model SocialMedia.Web.Models.UserViewModel

<section>
    <div class="feature-photo">
        <figure><img src="~/images/resources/timeline-1.jpg" alt=""></figure>
        <div class="add-btn">
            <span>0 Followers</span>
        </div>
        <div class="container-fluid">
            <div class="row merged">
                <div class="col-lg-2 col-sm-3">
                    <div class="user-avatar">
                        <figure>
                            <img src="@Url.Action("GetImage", "Home", new { userId = Model.Id})" onerror='this.src="/images/profile-icon.png"' alt="">
                        </figure>
                    </div>
                </div>
                <div class="col-lg-10 col-sm-9">
                    <div class="timeline-info" id="linksContainer">
                        <ul>
                            <li class="admin-name">
                                <h5>@Model.FirstName @Model.LastName</h5>
                                <span>@Model.Role</span>
                            </li>
                            <li>
                                <a class="" onclick="loadUserContainer('/Profile/', this)" title="" data-ripple="">Feed</a>
                                <a class="" onclick="loadUserContainer('/Profile/Friends', this)" title="" data-ripple="">Friends</a>
                                <a class="" onclick="loadUserContainer('/Profile/About', this)" title="" data-ripple="">About</a>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

Team13-SocialMedia/SocialMedia.Web/Views/Shared/_SettingsPartial.cshtml
@model SocialMedia.Services.DTOs.UserDTO

<section>
    <div class="feature-photo">
        <figure><img src="~/images/resources/timeline-1.jpg" alt=""></figure>
        <div class="add-btn">
            <span>0 Followers</span>
        </div>
        <div class="container-fluid">
            <div class="row merged">
                <div class="col-lg-2 col-sm-3">
                    <div class="user-avatar">
                        <figure>
                            <img src="@Url.Action("GetImage", "Home", new { userId = Model.Id})" onerror='this.src="/images/profile-icon.png"' alt="">
                        </figure>
                    </div>
                </div>
                <div class="col-lg-10 col-sm-9">
                    <div class="timeline-info" id="linksContainer">
                        <ul>
                            <li class="admin-name">
                                <h5>@Model.FirstName @Model.LastName</h5>
                            </li>
                            <li>
                                <a class="" asp-controller="Settings" asp-action="Index" title="" data-ripple="">Edit Profile</a>
                                <a class="" asp-controller="Settings" asp-action="Account" title="" data-ripple="">Privacy Settings</a>
                                <a class="" asp-controller="Settings" asp-action="Password" title="" data-ripple="">Change Password</a>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>

Team13-SocialMedia/SocialMedia.Web/Views/Shared/_UserPartial.cshtml
@model SocialMedia.Web.Models.UserViewModel

<section>
    <div class="feature-photo">
        <figure><img src="~/images/resources/timeline-1.jpg" alt=""></figure>
        <div class="add-btn">
            <span>0 Followers</span>
                <a href="" onclick='ajaxFriendRequest(@Model.Id, "SendRequest")' data-ripple="">Send Request</a>
        </div>
        <div class="container-fluid">
            <div class="row merged">
                <div class="col-lg-2 col-sm-3">
                    <div class="user-avatar">
                        <figure>
                            <img src="@Url.Action("GetImage", "Home", new { userId = Model.Id})" onerror='this.src="/images/profile-icon.png"' alt="">
                        </figure>
                    </div>
                </div>
                <div class="col-lg-10 col-sm-9">
                    <div class="timeline-info" id="linksContainer">
                        <ul>
                            <li class="admin-name">
                                <h5>@Model.FirstName @Model.LastName</h5>
                                <span>@Model.Role</span>
                            </li>
                            <li>
                                <a class="" onclick="loadUserContainer('@($"/User/Index/{Model.Id}")', this)" title="" data-ripple="">Feed</a>
                                <a class="" onclick="loadUserContainer('@($"/User/Friends/{Model.Id}")', this)" title="" data-ripple="">Friends</a>
                                <a class="" onclick="loadUserContainer('@($"/User/About/{Model.Id}")', this)" title="" data-ripple="">About</a>
                            </li>
                        </ul>
                    </div>
                </div>
            </div>
        </div>
    </div>
</section>